#include <iostream.h>
#include "lfout.h"
#include <conio.h>

#define STEUERSATZ_VERHEIRATET 0.18
#define STEUERSATZ_LEDIG       0.22
#define STEUERSATZ_KIRCHE      0.03
#define GEBUEHR_KIRCHE         0.70
#define KAPPUNGSGRENZE         50000.0

double fEinkommen;
double fKopfsteuer;
double fLohnsteuerBrutto;
double fLohnsteuer;
double fNettoeinkommen;
double fKinderabzug;
double fSteuersatz;
double fLohnsteuerBruttoOhneKinder;
double fZuVersteuerndesEinkommen;
double fGesamtsteuer;
double fGesamtsteuerEuro;
int    nErwachsene;
int    nKinder;
int    nVerheiratet;
int    nKirchenmitglied;
double fKirchensteuer;
double fKirchengebuehr;


void main (void)
{
	cout << "Jahreseinkommen .........[Na]: ";
   cin  >> fEinkommen;
   if (fEinkommen < 0.0)
   {
   	fEinkommen = 0.0;
   }

	cout << "Anzahl Erwachsene im Haushalt: ";
   cin  >> nErwachsene;
   if (nErwachsene < 1)
   {
   	nErwachsene = 1;
   }

	cout << "Anzahl Kinder im Haushalt ...: ";
   cin  >> nKinder;
   if (nKinder < 0)
   {
   	nKinder = 0;
   }

	cout << "Verheiratet ............[1/0]: ";
   cin  >> nVerheiratet;
   switch (nVerheiratet)
   {
   	case 1: break;
      default: nVerheiratet = 0; break;
   }

	cout << "Kirchenmitglied ........[1/0]: ";
   cin  >> nKirchenmitglied;
   switch (nKirchenmitglied)
   {
   	case 0: break;
      default: nKirchenmitglied = 1; break;
   }

   cout << endl << endl
        << "-----------------------------------------------------------------"
        << endl << endl;

   fKopfsteuer                 = 50 * nErwachsene;
   fLohnsteuerBrutto           = fEinkommen - fKopfsteuer;
   if (fLohnsteuerBrutto > KAPPUNGSGRENZE)
   {
   	fLohnsteuerBrutto = KAPPUNGSGRENZE;
   }

   switch (nKinder)
   {
   	case  0: fKinderabzug =  0.0; break;
   	case  1: fKinderabzug = 20.0; break;
      default: fKinderabzug = 45.0 + (nKinder-2) * 33.33;
   }

   fLohnsteuerBruttoOhneKinder = fLohnsteuerBrutto - fKinderabzug;

   if (nVerheiratet)
   {
   	fSteuersatz = STEUERSATZ_VERHEIRATET;
   }
   else
   {
   	fSteuersatz = STEUERSATZ_LEDIG;
   }
 	fLohnsteuer = fLohnsteuerBruttoOhneKinder * fSteuersatz;

   if (nKirchenmitglied)
   {
   	fKirchensteuer  = fLohnsteuerBruttoOhneKinder * STEUERSATZ_KIRCHE;
      fKirchengebuehr = GEBUEHR_KIRCHE;
   }
   else
   {
   	fKirchensteuer  = 0.0;
      fKirchengebuehr = 0.0;
   }

   fNettoeinkommen = fEinkommen - fLohnsteuer - fKopfsteuer
                                - fKirchensteuer - fKirchengebuehr;
   fGesamtsteuer     = fLohnsteuer + fKopfsteuer + fKirchensteuer + fKirchengebuehr;
   fGesamtsteuerEuro = fGesamtsteuer * 0.23561;

	cout << "  Anzahl Erwachsene .................: " << nErwachsene      << endl;
	cout << "  Anzahl Kinder .....................: " << nKinder          << endl;
	cout << "  Verheiratet .......................: " << nVerheiratet     << endl;
	cout << "  Kirchenmitglied....................: " << nKirchenmitglied << endl;
	cout << "  -------------------------------------------------------" << endl;
 	cout << "  Jahreseinkommen ...................: " << lfout(fEinkommen, 8,2)
                                                     << " Na" << endl;
   cout << "- Kopfsteuer pro Jahr ...............: " << lfout(fKopfsteuer, 8,2)
                                                     << " Na" << endl << endl;
   cout << "= Lohnsteuerpflichtig vor Kinderabzug: " << lfout(fLohnsteuerBrutto, 8,2)
                                                     << " Na" << endl;
   cout << "- Kinderabzug .......................: " << lfout(fKinderabzug, 8,2)
                                                     << " Na" << endl;
   cout << "= Lohnsteuerpflichtig ...............: " << lfout(fLohnsteuerBruttoOhneKinder, 8,2)
                                                     << " Na" << endl << endl;

 	cout << "  Jahreseinkommen ...................: " << lfout(fEinkommen, 8,2)
                                                     << " Na" << endl;
   cout << "- Kopfsteuer pro Jahr ...............: " << lfout(fKopfsteuer, 8,2)
                                                     << " Na" << endl;
   cout << "- Lohnsteuer ........................: " << lfout(fLohnsteuer, 8,2)
                                                     << " Na [" << fSteuersatz
                                                     << " %]" << endl;
   cout << "- Kirchensteuer......................: " << lfout(fKirchensteuer, 8,2)
                                                     << " Na" << endl;
   cout << "- Kirchengebuehr.....................: " << lfout(fKirchengebuehr, 8,2)
                                                     << " Na" << endl;
   cout << "= Gesamtsteuer ......................: " << lfout(fGesamtsteuer, 8,2)
                                                     << " Na ["
                                                     << lfout(fGesamtsteuerEuro, 4,2)
                                                     << " Euro]" << endl;
   cout << "= Nettoeinkommen ....................: " << lfout(fNettoeinkommen, 8,2)
                                                     << " Na" << endl;

   getch(); // Borland spezifisch
}